# -*- coding: utf-8 -*-
"""gru_submitted.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1CiYqY3gdGO8YrCYj92PZr45lns8qVGor
"""

# Commented out IPython magic to ensure Python compatibility.
import os #provides functions for interacting with the operating system
import numpy as np 
import pandas as pd
from matplotlib import pyplot as plt
import seaborn as sns
from sklearn.linear_model import LinearRegression
from sklearn.linear_model import LogisticRegression
from sklearn.tree import DecisionTreeClassifier
from sklearn.model_selection import train_test_split
from sklearn.metrics import r2_score, explained_variance_score, confusion_matrix, accuracy_score, classification_report, log_loss
from math import sqrt

from sklearn.cluster import KMeans, k_means

# %matplotlib inline

# To install sklearn type "pip install numpy scipy scikit-learn" to the anaconda terminal

# To change scientific numbers to float
np.set_printoptions(formatter={'float_kind':'{:f}'.format})

# Increases the size of sns plots
sns.set(rc={'figure.figsize':(8,6)})

# import sys
# !conda list Check the packages installed

train_data = pd.read_csv("/content/train.csv")

test_data = pd.read_csv("/content/test.csv")

test_data.shape

train_data.shape

test_data.isnull().sum()

train_data['DATES'] = pd.to_datetime(train_data['DATA_DATETIME']).dt.date
train_data['TIME'] = pd.to_datetime(train_data['DATA_DATETIME']).dt.time
train_data['POWER'].fillna((train_data['POWER'].mean()), inplace = True)

#now storing train data in train data 1
train_data1 = train_data
    
train_data1["RADIATION"]=train_data1["RADIATION"].apply(lambda x: x / 1361)
train_data1["TEMPERATURE"]=train_data1["TEMPERATURE"].apply(lambda x: x / 51)
train_data1["CLOUD_COVER"]=train_data1["CLOUD_COVER"].apply(lambda x: x / 100)
train_data1["HUMIDITY"]=train_data1["HUMIDITY"].apply(lambda x: x / 100)
train_data1["SURFACE_PRESSURE"]=train_data1["SURFACE_PRESSURE"].apply(lambda x: x / 1093)

# subset data for required columns
train_data = train_data[['BLOCK_ID',
                             'RADIATION',
                             'TEMPERATURE',
                             'CLOUD_COVER',
                             'HUMIDITY',
                             'PRECIP_PROBABILITY',
                             'SURFACE_PRESSURE',
                             'WIND_SPEED',
                             'POWER',
                             'DATES']]

train_data1 = train_data1[['BLOCK_ID',
                             'RADIATION',
                             'TEMPERATURE',
                             'CLOUD_COVER',
                             'HUMIDITY',
                             'PRECIP_PROBABILITY',
                             'SURFACE_PRESSURE',
                             'WIND_SPEED',
                             'DATES']]

train_datadf = train_data1.groupby('DATES').sum()
    
train_datadf.drop(['BLOCK_ID'], axis = 1, inplace = True)

test_data['DATA_DATETIME'] = pd.to_datetime(test_data['DATA_DATETIME'])
    
test_data['DATES'] = pd.to_datetime(test_data['DATA_DATETIME']).dt.date
test_data['TIME'] = pd.to_datetime(test_data['DATA_DATETIME']).dt.time
    
test_data1 = test_data
    
test_data1["RADIATION"]=test_data1["RADIATION"].apply(lambda x: x / 1361)
test_data1["TEMPERATURE"]=test_data1["TEMPERATURE"].apply(lambda x: x / 51)
test_data1["CLOUD_COVER"]=test_data1["CLOUD_COVER"].apply(lambda x: x / 100)
test_data1["HUMIDITY"]=test_data1["HUMIDITY"].apply(lambda x: x / 100)
test_data1["SURFACE_PRESSURE"]=test_data1["SURFACE_PRESSURE"].apply(lambda x: x / 1093)

# subset data for required columns
test_data = test_data[['BLOCK_ID',
                             'RADIATION',
                             'TEMPERATURE',
                             'CLOUD_COVER',
                             'HUMIDITY',
                             'PRECIP_PROBABILITY',
                             'SURFACE_PRESSURE',
                             'WIND_SPEED',
                             'POWER',
                             'DATES']]

test_data1 = test_data1[['BLOCK_ID',
                             'RADIATION',
                             'TEMPERATURE',
                             'CLOUD_COVER',
                             'HUMIDITY',
                             'PRECIP_PROBABILITY',
                             'SURFACE_PRESSURE',
                             'WIND_SPEED',
                             'DATES']]

test_datadf = test_data1.groupby('DATES').sum()
    
test_datadf.drop(['BLOCK_ID'], axis = 1, inplace = True)

test_datadf

# Commented out IPython magic to ensure Python compatibility.
# this according to elbow method to choose the no of clusters
# %pip install kneed
from sklearn.cluster import KMeans
from kneed import KneeLocator
from sklearn.metrics import silhouette_score
from sklearn.preprocessing import StandardScaler
Kmeans_Kwargs = {"init": "random", "n_init":10,"max_iter": 300, "random_state":42,}

# A list to hold sse values
sse = []
for k in range (1,11):
  Kmeans = KMeans(n_clusters=k, **Kmeans_Kwargs)
  Kmeans.fit(train_datadf)
  sse.append(Kmeans.inertia_)

kl = KneeLocator(range(1,11),sse,curve="convex",direction="decreasing")
opt_clusters = kl.elbow

kmeans = KMeans(
            init="random",
            n_clusters= opt_clusters,
            n_init=10,
            max_iter=300,
            random_state=42)

kmeans.fit(train_datadf)

kmeans.inertia_

train_centroids = kmeans.cluster_centers_

kmeans.n_iter_

kmeans.labels_

train_datadf['CLUSTER'] = kmeans.labels_

from numpy import array
import numpy as np

test = np.array(test_datadf)
train = np.transpose(train_centroids)
train =pd.DataFrame(data=train)
test = np.transpose(test)
test  = pd.DataFrame(test)

def calculate_absolute(i,y):
  ds = 0
  for e in i:
    sub = i[e] - y
    if sub.sum() < ds:
      ds = sub.sum()
      output = e
    return e

value = calculate_absolute(train,test[0])

def find_clusters(value, df, colname):
      exactmatch = df[df[colname]==value]
      return exactmatch

train_bestdays = find_clusters(value, train_datadf, "CLUSTER")

train_bestdays = train_bestdays.reset_index()

train_bestdays = train_bestdays["DATES"]
train_bestdays = pd.DataFrame(train_bestdays)

train_merge = pd.merge(train_bestdays, train_data, how='left', on = 'DATES')

df = train_merge

import scipy
import numpy
import tensorflow as tf
from tensorflow import keras
from tensorflow.keras import Sequential, layers, callbacks
from tensorflow.keras.layers import Dense, LSTM, Dropout, GRU, Bidirectional
import pandas as pd
import numpy as np

from sklearn.preprocessing import MinMaxScaler
from sklearn.model_selection import train_test_split

from matplotlib import pyplot as plt
from IPython.core.pylabtools import figsize

from pandas.plotting import register_matplotlib_converters
register_matplotlib_converters()
import seaborn as sns

tf.random.set_seed(1234)
df = df.set_index('DATES')
df_test = test_data
df_test = df_test.set_index('DATES')

test_data

train_size1 = int(len(df))
test_size1 = int(len(df_test))
train_dataset1, test_dataset1 = df.iloc[:train_size1], df.iloc[:test_size1]

# splitting train data 
X_train1 = train_dataset1.drop('POWER', axis = 1)
y_train1 = train_dataset1.loc[:,['POWER']]

# Split test data to X and y
X_test1 = test_dataset1.drop('POWER', axis = 1)
y_test1 = test_dataset1.loc[:,['POWER']]

# Transform X_train, y_train, X_test and y_test

# Different scaler for input and output
scaler_x1 = MinMaxScaler(feature_range = (0,1))
scaler_y1 = MinMaxScaler(feature_range = (0,1))

# Fit the scaler using available training data
input_scaler1 = scaler_x1.fit(X_train1)
output_scaler1 = scaler_y1.fit(y_train1)

# Apply the scaler to training data
train_y_norm1 = output_scaler1.transform(y_train1)
train_x_norm1 = input_scaler1.transform(X_train1)

# Apply the scaler to test data
test_y_norm1 = output_scaler1.transform(y_test1)
test_x_norm1 = input_scaler1.transform(X_test1)

def create_dataset (X, y, time_steps = 1):
    Xs, ys = [], []
    
    for i in range(len(X)-time_steps):
        v = X[i:i+time_steps, :]
        Xs.append(v)
        ys.append(y[i+time_steps])
        
    return np.array(Xs), np.array(ys)


TIME_STEPS = 1

X_test, y_test = create_dataset(test_x_norm1, test_y_norm1, TIME_STEPS)
X_train, y_train = create_dataset(train_x_norm1, train_y_norm1, TIME_STEPS)
print('X_train.shape: ', X_test.shape)
print('y_train.shape: ', y_train.shape)
print('X_test.shape: ', X_test.shape) 
print('y_test.shape: ', y_train.shape)

# Create BiLSTM model
def create_model_bilstm(units):
    model = Sequential()
    # First layer of BiLSTM
    model.add(Bidirectional(LSTM(units = units, return_sequences=True), 
                            input_shape=(X_train.shape[1], X_train.shape[2])))
    # Second layer of BiLSTM
    model.add(Bidirectional(LSTM(units = units)))
    model.add(Dense(1))
    #Compile model
    model.compile(loss='mse', optimizer='adam')
    return model


# Create LSTM or GRU model
def create_model(units, m):
    model = Sequential()
    # First layer of LSTM
    model.add(m (units = units, return_sequences = True, 
                 input_shape = [X_train.shape[1], X_train.shape[2]]))
    model.add(Dropout(0.2)) 
    # Second layer of LSTM
    model.add(m (units = units))                 
    model.add(Dropout(0.2))
    model.add(Dense(units = 1)) 
    #Compile model
    model.compile(loss='mse', optimizer='adam')
    return model


# BiLSTM
model_bilstm = create_model_bilstm(64)

# GRU and LSTM 
model_gru = create_model(64, GRU)
model_lstm = create_model(64, LSTM)

# Fit BiLSTM, LSTM and GRU
def fit_model(model):
    early_stop = keras.callbacks.EarlyStopping(monitor = 'val_loss',
                                               patience = 10)

    # shuffle = False because the order of the data matters
    history = model.fit(X_train, y_train, epochs = 100, validation_split = 0.2,
                    batch_size = 32, shuffle = False, callbacks = [early_stop])
    return history

history_bilstm = fit_model(model_bilstm)
history_lstm = fit_model(model_lstm)
history_gru = fit_model(model_gru)

def plot_loss (history, model_name):
    plt.figure(figsize = (10, 6))
    plt.plot(history.history['loss'])
    plt.plot(history.history['val_loss'])
    plt.title('Model Train vs Validation Loss for ' + model_name)
    plt.ylabel('Loss')
    plt.xlabel('epoch')
    plt.legend(['Train loss', 'Validation loss'], loc='upper right')
    #plt.savefig('C:/Users/nious/Documents/Medium/LSTM&GRU/loss_'+model_name+'.jpg', format='jpg', dpi=1000)

plot_loss (history_bilstm, 'BiLSTM')
plot_loss (history_lstm, 'LSTM')
plot_loss (history_gru, 'GRU')

# Note that I have to use scaler_y
y_test = scaler_y1.inverse_transform(y_test)
y_train = scaler_y1.inverse_transform(y_train)

def prediction(model):
    prediction = model.predict(X_test)
    prediction = scaler_y1.inverse_transform(prediction)
    return prediction

prediction_bilstm = prediction(model_bilstm)
prediction_lstm = prediction(model_lstm)
prediction_gru = prediction(model_gru)

def plot_future(prediction, model_name, y_test):
    
    plt.figure(figsize=(10, 6))
    
    range_future = len(prediction)

    plt.plot(np.arange(range_future), np.array(y_test), label='True Future')
    plt.plot(np.arange(range_future), np.array(prediction),label='Prediction')

    plt.title('True future vs prediction for ' + model_name)
    plt.legend(loc='upper left')
    plt.xlabel('Time (15 minute blocks)')
    plt.ylabel('power (MW/per.15 minute block)')
    #plt.savefig('C:/Users/nious/Documents/Medium/LSTM&GRU/predic_'+model_name+'.jpg', format='jpg', dpi=1000)
    
    
plot_future(prediction_bilstm, 'BiLSTM', y_test)
plot_future(prediction_lstm, 'LSTM', y_test)
plot_future(prediction_gru, 'GRU', y_test)

def evaluate_prediction(predictions, actual, model_name):
    errors = predictions - actual
    mse = np.square(errors).mean()
    rmse = np.sqrt(mse)
    mae = np.abs(errors).mean()

    print(model_name + ':')
    print('Mean Absolute Error: {:.4f}'.format(mae))
    print('Root Mean Square Error: {:.4f}'.format(rmse))
    print('')


evaluate_prediction(prediction_bilstm, y_test, 'Bidirectional LSTM')
evaluate_prediction(prediction_lstm, y_test, 'LSTM')
evaluate_prediction(prediction_gru, y_test, 'GRU')

